/* refSeqStatus.c was originally generated by the autoSql program, which also 
 * generated refSeqStatus.h and refSeqStatus.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "refSeqStatus.h"

void refSeqStatusStaticLoad(char **row, struct refSeqStatus *ret)
/* Load a row from refSeqStatus table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne,i;
char *s;

ret->mrnaAcc = row[0];
ret->status = row[1];
}

struct refSeqStatus *refSeqStatusLoad(char **row)
/* Load a refSeqStatus from row fetched with select * from refSeqStatus
 * from database.  Dispose of this with refSeqStatusFree(). */
{
struct refSeqStatus *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->mrnaAcc = cloneString(row[0]);
ret->status = cloneString(row[1]);
return ret;
}

struct refSeqStatus *refSeqStatusLoadAll(char *fileName) 
/* Load all refSeqStatus from a tab-separated file.
 * Dispose of this with refSeqStatusFreeList(). */
{
struct refSeqStatus *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileRow(lf, row))
    {
    el = refSeqStatusLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct refSeqStatus *refSeqStatusLoadWhere(struct sqlConnection *conn, char *table, char *where)
/* Load all refSeqStatus from table that satisfy where clause. The
 * where clause may be NULL in which case whole table is loaded
 * Dispose of this with refSeqStatusFreeList(). */
{
struct refSeqStatus *list = NULL, *el;
struct dyString *query = dyStringNew(256);
struct sqlResult *sr;
char **row;

dyStringPrintf(query, "select * from %s", table);
if (where != NULL)
    dyStringPrintf(query, " where %s", where);
sr = sqlGetResult(conn, query->string);
while ((row = sqlNextRow(sr)) != NULL)
    {
    el = refSeqStatusLoad(row);
    slAddHead(&list, el);
    }
slReverse(&list);
sqlFreeResult(&sr);
dyStringFree(&query);
return list;
}

struct refSeqStatus *refSeqStatusCommaIn(char **pS, struct refSeqStatus *ret)
/* Create a refSeqStatus out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new refSeqStatus */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->mrnaAcc = sqlStringComma(&s);
ret->status = sqlStringComma(&s);
*pS = s;
return ret;
}

void refSeqStatusFree(struct refSeqStatus **pEl)
/* Free a single dynamically allocated refSeqStatus such as created
 * with refSeqStatusLoad(). */
{
struct refSeqStatus *el;

if ((el = *pEl) == NULL) return;
freeMem(el->mrnaAcc);
freeMem(el->status);
freez(pEl);
}

void refSeqStatusFreeList(struct refSeqStatus **pList)
/* Free a list of dynamically allocated refSeqStatus's */
{
struct refSeqStatus *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    refSeqStatusFree(&el);
    }
*pList = NULL;
}

void refSeqStatusOutput(struct refSeqStatus *el, FILE *f, char sep, char lastSep) 
/* Print out refSeqStatus.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->mrnaAcc);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->status);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

